From 535dbd45945412a27ac0eb69bb0ef9c921ba5079 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Thu, 27 Mar 2014 19:11:45 +0100
Subject: [PATCH] WIP ACPICA-20140325

---
 sys/conf/acpi.mk                                   |   1 +
 sys/conf/files                                     |   2 +
 sys/contrib/dev/acpica/changes.txt                 | 100 +++
 .../dev/acpica/generate/unix/acpibin/Makefile      |   5 +-
 .../dev/acpica/generate/unix/acpidump/Makefile     |   5 +-
 .../dev/acpica/generate/unix/acpiexamples/Makefile |   1 +
 .../dev/acpica/generate/unix/acpiexec/Makefile     |   3 +
 .../dev/acpica/generate/unix/acpihelp/Makefile     |   1 +
 .../dev/acpica/generate/unix/acpinames/Makefile    |   2 +
 .../dev/acpica/generate/unix/acpisrc/Makefile      |   5 +-
 sys/contrib/dev/acpica/generate/unix/iasl/Makefile |   3 +
 sys/contrib/dev/acpica/source/common/adfile.c      |   9 +-
 sys/contrib/dev/acpica/source/common/adisasm.c     |  87 +-
 sys/contrib/dev/acpica/source/common/adwalk.c      |   8 +-
 sys/contrib/dev/acpica/source/common/ahids.c       | 214 +++++
 sys/contrib/dev/acpica/source/common/ahpredef.c    |  34 +
 sys/contrib/dev/acpica/source/common/cmfsize.c     | 111 +++
 sys/contrib/dev/acpica/source/common/dmextern.c    |  33 +-
 .../dev/acpica/source/compiler/aslcompile.c        |   2 +-
 sys/contrib/dev/acpica/source/compiler/aslerror.c  |   6 +-
 sys/contrib/dev/acpica/source/compiler/aslfileio.c |  72 +-
 sys/contrib/dev/acpica/source/compiler/aslmain.c   |  42 +
 .../dev/acpica/source/compiler/aslmessages.h       |   2 +-
 .../dev/acpica/source/compiler/asloptions.c        |   1 +
 sys/contrib/dev/acpica/source/compiler/aslstubs.c  |   2 +-
 sys/contrib/dev/acpica/source/compiler/aslutils.c  |   2 +-
 .../dev/acpica/source/compiler/dtcompiler.h        |   4 -
 sys/contrib/dev/acpica/source/compiler/dtio.c      |  14 +-
 sys/contrib/dev/acpica/source/compiler/dtutils.c   |  30 -
 .../dev/acpica/source/components/debugger/dbcmds.c |  27 +-
 .../acpica/source/components/debugger/dbfileio.c   |  37 +-
 .../acpica/source/components/debugger/dbmethod.c   |   5 +
 .../source/components/disassembler/dmbuffer.c      | 114 +--
 .../source/components/disassembler/dmopcode.c      | 195 ++++-
 .../acpica/source/components/disassembler/dmwalk.c |  11 +-
 .../acpica/source/components/dispatcher/dsmethod.c |  19 +-
 .../dev/acpica/source/components/events/evmisc.c   |   2 +-
 .../dev/acpica/source/components/events/evsci.c    |   2 +-
 .../dev/acpica/source/components/events/evxface.c  |  62 +-
 .../acpica/source/components/executer/exconfig.c   |  79 +-
 .../dev/acpica/source/components/executer/exdump.c |   3 +-
 .../dev/acpica/source/components/tables/tbdata.c   | 816 +++++++++++++++++++
 .../dev/acpica/source/components/tables/tbfadt.c   |   4 +-
 .../dev/acpica/source/components/tables/tbfind.c   |   2 +-
 .../dev/acpica/source/components/tables/tbinstal.c | 888 ++++++++-------------
 .../dev/acpica/source/components/tables/tbutils.c  | 175 +---
 .../dev/acpica/source/components/tables/tbxface.c  |   6 +-
 .../dev/acpica/source/components/tables/tbxfload.c |  92 ++-
 .../acpica/source/components/utilities/utdecode.c  |  77 +-
 .../acpica/source/components/utilities/utstring.c  |   2 +-
 sys/contrib/dev/acpica/source/include/acapps.h     |  12 +-
 sys/contrib/dev/acpica/source/include/acbuffer.h   |   5 -
 sys/contrib/dev/acpica/source/include/acconfig.h   |   4 -
 sys/contrib/dev/acpica/source/include/acdebug.h    |   4 -
 sys/contrib/dev/acpica/source/include/acdisasm.h   |  16 +-
 sys/contrib/dev/acpica/source/include/acdispat.h   |   4 -
 sys/contrib/dev/acpica/source/include/acevents.h   |   4 -
 sys/contrib/dev/acpica/source/include/acexcep.h    |   4 -
 sys/contrib/dev/acpica/source/include/acglobal.h   |  15 +-
 sys/contrib/dev/acpica/source/include/achware.h    |   4 -
 sys/contrib/dev/acpica/source/include/acinterp.h   |   4 -
 sys/contrib/dev/acpica/source/include/aclocal.h    |  12 +-
 sys/contrib/dev/acpica/source/include/acmacros.h   |   4 -
 sys/contrib/dev/acpica/source/include/acnamesp.h   |   4 -
 sys/contrib/dev/acpica/source/include/acobject.h   |   7 +-
 sys/contrib/dev/acpica/source/include/acoutput.h   |   4 -
 sys/contrib/dev/acpica/source/include/acparser.h   |   4 -
 sys/contrib/dev/acpica/source/include/acpiosxf.h   |   4 -
 sys/contrib/dev/acpica/source/include/acpixf.h     |  13 +-
 sys/contrib/dev/acpica/source/include/acpredef.h   |   4 -
 sys/contrib/dev/acpica/source/include/acresrc.h    |   4 -
 sys/contrib/dev/acpica/source/include/acrestyp.h   |   4 -
 sys/contrib/dev/acpica/source/include/acstruct.h   |   5 -
 sys/contrib/dev/acpica/source/include/actables.h   |  91 ++-
 sys/contrib/dev/acpica/source/include/actbl.h      |  15 +-
 sys/contrib/dev/acpica/source/include/actbl1.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actbl2.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actbl3.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actypes.h    |   4 -
 sys/contrib/dev/acpica/source/include/acutils.h    |  16 +-
 sys/contrib/dev/acpica/source/include/amlcode.h    |   5 -
 sys/contrib/dev/acpica/source/include/amlresrc.h   |   5 -
 .../dev/acpica/source/include/platform/acgcc.h     |  11 +
 .../dev/acpica/source/include/platform/aclinux.h   |  13 +-
 .../source/os_specific/service_layers/oslinuxtbl.c |  32 +-
 .../source/os_specific/service_layers/osunixdir.c  |   2 +-
 .../source/os_specific/service_layers/osunixxf.c   |   2 +-
 .../source/os_specific/service_layers/oswintbl.c   |  26 +-
 .../source/os_specific/service_layers/oswinxf.c    |   2 +-
 .../dev/acpica/source/tools/acpibin/abcompare.c    | 361 ++-------
 .../dev/acpica/source/tools/acpibin/abmain.c       |  15 +-
 .../dev/acpica/source/tools/acpibin/acpibin.h      |   6 -
 .../dev/acpica/source/tools/acpidump/acpidump.h    |   4 -
 .../dev/acpica/source/tools/acpidump/apdump.c      |  44 +-
 .../dev/acpica/source/tools/acpidump/apfiles.c     |  42 +-
 .../dev/acpica/source/tools/acpidump/apmain.c      |   2 +-
 .../dev/acpica/source/tools/acpiexec/aecommon.h    |   5 -
 .../dev/acpica/source/tools/acpiexec/aehandlers.c  |   6 +-
 .../dev/acpica/source/tools/acpihelp/acpihelp.h    |  14 +-
 .../dev/acpica/source/tools/acpihelp/ahamlops.c    |   2 +-
 .../dev/acpica/source/tools/acpihelp/ahdecode.c    | 140 ++--
 .../dev/acpica/source/tools/acpihelp/ahmain.c      |  41 +-
 .../dev/acpica/source/tools/acpisrc/asfile.c       |  10 +-
 .../dev/acpica/source/tools/acpisrc/astable.c      |   9 +
 sys/dev/acpica/Makefile                            |   3 +-
 sys/dev/acpica/Osd/OsdSchedule.c                   |   8 +
 sys/dev/acpica/Osd/OsdTable.c                      |   9 +
 usr.sbin/acpi/acpibin/Makefile                     |   5 +-
 usr.sbin/acpi/acpidump/Makefile                    |   5 +-
 usr.sbin/acpi/acpiexec/Makefile                    |   3 +
 usr.sbin/acpi/acpihelp/Makefile                    |   1 +
 usr.sbin/acpi/acpinames/Makefile                   |   2 +
 usr.sbin/acpi/acpisrc/Makefile                     |   5 +-
 usr.sbin/acpi/iasl/Makefile                        |   3 +
 114 files changed, 2795 insertions(+), 1756 deletions(-)
 create mode 100644 sys/contrib/dev/acpica/source/common/ahids.c
 create mode 100644 sys/contrib/dev/acpica/source/common/cmfsize.c
 create mode 100644 sys/contrib/dev/acpica/source/components/tables/tbdata.c

diff --git a/sys/conf/acpi.mk b/sys/conf/acpi.mk
index ae780d3..94492be 100644
--- a/sys/conf/acpi.mk
+++ b/sys/conf/acpi.mk
@@ -8,6 +8,7 @@ SYSDIR=	$S
 .endif
 
 ACPICA_KERN_PATHS = \
+	${SYSDIR}/${ACPICA_DIR}/common			\
 	${SYSDIR}/${ACPICA_COMP_DIR}/dispatcher 	\
 	${SYSDIR}/${ACPICA_COMP_DIR}/executer		\
 	${SYSDIR}/${ACPICA_COMP_DIR}/parser		\
diff --git a/sys/conf/files b/sys/conf/files
index 660c858..d5901a3 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -2233,6 +2233,7 @@ kern/dsched/bfq/wf2q.c			optional dsched_bfq
 kern/dsched/bfq/bfq_helper_thread.c	optional dsched_bfq
 
 # ACPICA code
+${ACPICA_DIR}/common/ahids.c			optional acpi
 ${ACPICA_COMP_DIR}/debugger/dbcmds.c		optional acpi acpi_debug
 ${ACPICA_COMP_DIR}/debugger/dbconvert.c		optional acpi acpi_debug
 ${ACPICA_COMP_DIR}/debugger/dbdisply.c		optional acpi acpi_debug
@@ -2367,6 +2368,7 @@ ${ACPICA_COMP_DIR}/resources/rsmisc.c		optional acpi
 ${ACPICA_COMP_DIR}/resources/rsserial.c		optional acpi
 ${ACPICA_COMP_DIR}/resources/rsutils.c		optional acpi
 ${ACPICA_COMP_DIR}/resources/rsxface.c		optional acpi
+${ACPICA_COMP_DIR}/tables/tbdata.c		optional acpi
 ${ACPICA_COMP_DIR}/tables/tbfadt.c		optional acpi
 ${ACPICA_COMP_DIR}/tables/tbfind.c		optional acpi
 ${ACPICA_COMP_DIR}/tables/tbinstal.c		optional acpi
diff --git a/sys/contrib/dev/acpica/generate/unix/acpibin/Makefile b/sys/contrib/dev/acpica/generate/unix/acpibin/Makefile
index 2a5aff6..c33c085 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpibin/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpibin/Makefile
@@ -29,6 +29,8 @@ HEADERS = \
 OBJECTS = \
 	$(OBJDIR)/abcompare.o\
 	$(OBJDIR)/abmain.o\
+	$(OBJDIR)/cmfsize.o\
+	$(OBJDIR)/getopt.o\
 	$(OBJDIR)/utalloc.o\
 	$(OBJDIR)/utbuffer.o\
 	$(OBJDIR)/utcache.o\
@@ -42,8 +44,7 @@ OBJECTS = \
 	$(OBJDIR)/utstate.o\
 	$(OBJDIR)/utstring.o\
 	$(OBJDIR)/utxferror.o\
-	$(OBJDIR)/osunixxf.o\
-	$(OBJDIR)/getopt.o
+	$(OBJDIR)/osunixxf.o
 
 #
 # Flags specific to acpibin
diff --git a/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile b/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
index b7d2021..8a9cda5 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpidump/Makefile
@@ -31,6 +31,8 @@ OBJECTS = \
 	$(OBJDIR)/apdump.o\
 	$(OBJDIR)/apfiles.o\
 	$(OBJDIR)/apmain.o\
+	$(OBJDIR)/cmfsize.o\
+	$(OBJDIR)/getopt.o\
 	$(OBJDIR)/osunixdir.o\
 	$(OBJDIR)/osunixmap.o\
 	$(OBJDIR)/tbprint.o\
@@ -39,8 +41,7 @@ OBJECTS = \
 	$(OBJDIR)/utexcep.o\
 	$(OBJDIR)/utmath.o\
 	$(OBJDIR)/utstring.o\
-	$(OBJDIR)/utxferror.o\
-	$(OBJDIR)/getopt.o
+	$(OBJDIR)/utxferror.o
 
 #
 # Per-host interfaces
diff --git a/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile b/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
index 5f0b3b6..c2f3c73 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpiexamples/Makefile
@@ -103,6 +103,7 @@ OBJECTS = \
 	$(OBJDIR)/psutils.o\
 	$(OBJDIR)/pswalk.o\
 	$(OBJDIR)/psxface.o\
+	$(OBJDIR)/tbdata.o\
 	$(OBJDIR)/tbfadt.o\
 	$(OBJDIR)/tbfind.o\
 	$(OBJDIR)/tbinstal.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
index 63fa77c..84cc978 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
@@ -44,6 +44,8 @@ OBJECTS = \
 	$(OBJDIR)/aehandlers.o\
 	$(OBJDIR)/aemain.o\
 	$(OBJDIR)/aetables.o\
+	$(OBJDIR)/ahids.o\
+	$(OBJDIR)/cmfsize.o\
 	$(OBJDIR)/dbcmds.o\
 	$(OBJDIR)/dbconvert.o\
 	$(OBJDIR)/dbdisply.o\
@@ -179,6 +181,7 @@ OBJECTS = \
 	$(OBJDIR)/rsserial.o\
 	$(OBJDIR)/rsutils.o\
 	$(OBJDIR)/rsxface.o\
+	$(OBJDIR)/tbdata.o\
 	$(OBJDIR)/tbfadt.o\
 	$(OBJDIR)/tbfind.o\
 	$(OBJDIR)/tbinstal.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/acpihelp/Makefile b/sys/contrib/dev/acpica/generate/unix/acpihelp/Makefile
index 2dbd13b..da6ee49 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpihelp/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpihelp/Makefile
@@ -31,6 +31,7 @@ OBJECTS = \
 	$(OBJDIR)/ahaslkey.o\
 	$(OBJDIR)/ahaslops.o\
 	$(OBJDIR)/ahdecode.o\
+	$(OBJDIR)/ahids.o\
 	$(OBJDIR)/ahpredef.o\
 	$(OBJDIR)/ahmain.o\
 	$(OBJDIR)/getopt.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/acpinames/Makefile b/sys/contrib/dev/acpica/generate/unix/acpinames/Makefile
index 1438200..00a0026 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpinames/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpinames/Makefile
@@ -38,6 +38,7 @@ OBJECTS = \
 	$(OBJDIR)/anmain.o\
 	$(OBJDIR)/anstubs.o\
 	$(OBJDIR)/antables.o\
+	$(OBJDIR)/cmfsize.o\
 	$(OBJDIR)/dbfileio.o\
 	$(OBJDIR)/dsfield.o\
 	$(OBJDIR)/dsmthdat.o\
@@ -79,6 +80,7 @@ OBJECTS = \
 	$(OBJDIR)/psutils.o\
 	$(OBJDIR)/pswalk.o\
 	$(OBJDIR)/psxface.o\
+	$(OBJDIR)/tbdata.o\
 	$(OBJDIR)/tbfadt.o\
 	$(OBJDIR)/tbfind.o\
 	$(OBJDIR)/tbinstal.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/acpisrc/Makefile b/sys/contrib/dev/acpica/generate/unix/acpisrc/Makefile
index bf87817..50199ce 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpisrc/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpisrc/Makefile
@@ -33,8 +33,9 @@ OBJECTS = \
     $(OBJDIR)/asremove.o\
     $(OBJDIR)/astable.o\
     $(OBJDIR)/asutils.o\
-    $(OBJDIR)/osunixdir.o\
-    $(OBJDIR)/getopt.o
+	$(OBJDIR)/cmfsize.o\
+    $(OBJDIR)/getopt.o \
+    $(OBJDIR)/osunixdir.o
 
 #
 # Compile flags specific to acpisrc
diff --git a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
index fd58de9..f0662b7 100644
--- a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
@@ -46,6 +46,7 @@ OBJECTS = \
 	$(OBJDIR)/adfile.o\
 	$(OBJDIR)/adisasm.o\
 	$(OBJDIR)/adwalk.o\
+	$(OBJDIR)/ahids.o\
 	$(OBJDIR)/ahpredef.o\
 	$(OBJDIR)/aslanalyze.o\
 	$(OBJDIR)/aslbtypes.o\
@@ -89,6 +90,7 @@ OBJECTS = \
 	$(OBJDIR)/asluuid.o\
 	$(OBJDIR)/aslwalks.o\
 	$(OBJDIR)/aslxref.o\
+	$(OBJDIR)/cmfsize.o\
 	$(OBJDIR)/dtcompile.o\
 	$(OBJDIR)/dtexpress.o\
 	$(OBJDIR)/dtfield.o\
@@ -171,6 +173,7 @@ OBJECTS = \
 	$(OBJDIR)/pstree.o\
 	$(OBJDIR)/psutils.o\
 	$(OBJDIR)/pswalk.o\
+	$(OBJDIR)/tbdata.o\
 	$(OBJDIR)/tbfadt.o\
 	$(OBJDIR)/tbinstal.o\
 	$(OBJDIR)/tbprint.o\
diff --git a/sys/contrib/dev/acpica/source/common/adfile.c b/sys/contrib/dev/acpica/source/common/adfile.c
index 91b35c5..0b70d69 100644
--- a/sys/contrib/dev/acpica/source/common/adfile.c
+++ b/sys/contrib/dev/acpica/source/common/adfile.c
@@ -203,11 +203,16 @@ FlGenerateFilename (
 
 
     /*
-     * Copy the original filename to a new buffer. Leave room for the worst case
-     * where we append the suffix, an added dot and the null terminator.
+     * Copy the original filename to a new buffer. Leave room for the worst
+     * case where we append the suffix, an added dot and the null terminator.
      */
     NewFilename = ACPI_ALLOCATE_ZEROED ((ACPI_SIZE)
         strlen (InputFilename) + strlen (Suffix) + 2);
+    if (!NewFilename)
+    {
+        return (NULL);
+    }
+
     strcpy (NewFilename, InputFilename);
 
     /* Try to find the last dot in the filename */
diff --git a/sys/contrib/dev/acpica/source/common/adisasm.c b/sys/contrib/dev/acpica/source/common/adisasm.c
index 2a8fac3..7ca1623 100644
--- a/sys/contrib/dev/acpica/source/common/adisasm.c
+++ b/sys/contrib/dev/acpica/source/common/adisasm.c
@@ -79,10 +79,6 @@ NsSetupNamespaceListing (
 
 /* Local prototypes */
 
-static UINT32
-AdGetFileSize (
-    FILE                    *File);
-
 static void
 AdCreateTableHeader (
     char                    *Filename,
@@ -157,38 +153,6 @@ static ACPI_PARSE_OBJECT    *AcpiGbl_ParseOpRoot;
 
 /*******************************************************************************
  *
- * FUNCTION:    AdGetFileSize
- *
- * PARAMETERS:  File                - Open file handle
- *
- * RETURN:      File Size
- *
- * DESCRIPTION: Get current file size. Uses seek-to-EOF. File must be open.
- *
- ******************************************************************************/
-
-static UINT32
-AdGetFileSize (
-    FILE                    *File)
-{
-    UINT32                  FileSize;
-    long                    Offset;
-
-
-    Offset = ftell (File);
-
-    fseek (File, 0, SEEK_END);
-    FileSize = (UINT32) ftell (File);
-
-    /* Restore file pointer */
-
-    fseek (File, Offset, SEEK_SET);
-    return (FileSize);
-}
-
-
-/*******************************************************************************
- *
  * FUNCTION:    AdInitialize
  *
  * PARAMETERS:  None
@@ -206,7 +170,7 @@ AdInitialize (
     ACPI_STATUS             Status;
 
 
-    /* ACPI CA subsystem initialization */
+    /* ACPICA subsystem initialization */
 
     Status = AcpiOsInitialize ();
     if (ACPI_FAILURE (Status))
@@ -381,7 +345,7 @@ AdAmlDisassemble (
         /* Create/Open a disassembly output file */
 
         DisasmFilename = FlGenerateFilename (Prefix, FILE_SUFFIX_DISASSEMBLY);
-        if (!OutFilename)
+        if (!DisasmFilename)
         {
             fprintf (stderr, "Could not generate output filename\n");
             Status = AE_ERROR;
@@ -413,7 +377,7 @@ AdAmlDisassemble (
         fprintf (stderr, "Acpi Data Table [%4.4s] decoded\n",
             Table->Signature);
         fprintf (stderr, "Formatted output:  %s - %u bytes\n",
-            DisasmFilename, AdGetFileSize (File));
+            DisasmFilename, CmGetFileSize (File));
     }
     else
     {
@@ -469,9 +433,10 @@ AdAmlDisassemble (
                 "reparsing with new information\n",
                 AcpiDmGetExternalMethodCount ());
 
-            /* Reparse, rebuild namespace. no need to xref namespace */
+            /* Reparse, rebuild namespace */
 
             AcpiPsDeleteParseTree (AcpiGbl_ParseOpRoot);
+            AcpiGbl_ParseOpRoot = NULL;
             AcpiNsDeleteNamespaceSubtree (AcpiGbl_RootNode);
 
             AcpiGbl_RootNode                    = NULL;
@@ -485,6 +450,9 @@ AdAmlDisassemble (
             AcpiGbl_RootNodeStruct.Flags        = 0;
 
             Status = AcpiNsRootInitialize ();
+
+            /* New namespace, add the external definitions first */
+
             AcpiDmAddExternalsToNamespace ();
 
             /* Parse the table again. No need to reload it, however */
@@ -497,6 +465,14 @@ AdAmlDisassemble (
                 goto Cleanup;
             }
 
+            /* Cross reference the namespace again */
+
+            AcpiDmFinishNamespaceLoad (AcpiGbl_ParseOpRoot,
+                AcpiGbl_RootNode, OwnerId);
+
+            AcpiDmCrossReferenceNamespace (AcpiGbl_ParseOpRoot,
+                AcpiGbl_RootNode, OwnerId);
+
             if (AslCompilerdebug)
             {
                 AcpiOsPrintf ("/**** After second load and resource conversion\n");
@@ -531,7 +507,7 @@ AdAmlDisassemble (
 
             fprintf (stderr, "Disassembly completed\n");
             fprintf (stderr, "ASL Output:    %s - %u bytes\n",
-                DisasmFilename, AdGetFileSize (File));
+                DisasmFilename, CmGetFileSize (File));
         }
     }
 
@@ -568,7 +544,7 @@ Cleanup:
  *
  * RETURN:      None
  *
- * DESCRIPTION: Create the disassembler header, including ACPI CA signon with
+ * DESCRIPTION: Create the disassembler header, including ACPICA signon with
  *              current time and date.
  *
  *****************************************************************************/
@@ -600,7 +576,7 @@ AdDisassemblerHeader (
  *
  * RETURN:      None
  *
- * DESCRIPTION: Create the ASL table header, including ACPI CA signon with
+ * DESCRIPTION: Create the ASL table header, including ACPICA signon with
  *              current time and date.
  *
  *****************************************************************************/
@@ -678,8 +654,17 @@ AdCreateTableHeader (
     else
     {
         NewFilename = ACPI_ALLOCATE_ZEROED (9);
-        strncat (NewFilename, Table->Signature, 4);
-        strcat (NewFilename, ".aml");
+        if (NewFilename)
+        {
+            strncat (NewFilename, Table->Signature, 4);
+            strcat (NewFilename, ".aml");
+        }
+    }
+
+    if (!NewFilename)
+    {
+        AcpiOsPrintf (" **** Could not generate AML output filename\n");
+        return;
     }
 
     /* Open the ASL definition block */
@@ -872,7 +857,8 @@ AdParseTable (
     if (LoadTable)
     {
         Status = AcpiTbStoreTable ((ACPI_PHYSICAL_ADDRESS) Table, Table,
-                    Table->Length, ACPI_TABLE_ORIGIN_ALLOCATED, &TableIndex);
+                    Table->Length, ACPI_TABLE_ORIGIN_INTERNAL_VIRTUAL,
+                    &TableIndex);
         if (ACPI_FAILURE (Status))
         {
             return (Status);
@@ -907,9 +893,12 @@ AdParseTable (
         return (AE_OK);
     }
 
-    /* Pass 3: Parse control methods and link their parse trees into the main parse tree */
-
-    fprintf (stderr, "Parsing Deferred Opcodes (Methods/Buffers/Packages/Regions)\n");
+    /*
+     * Pass 3: Parse control methods and link their parse trees
+     * into the main parse tree
+     */
+    fprintf (stderr,
+        "Parsing Deferred Opcodes (Methods/Buffers/Packages/Regions)\n");
     Status = AcpiDmParseDeferredOps (AcpiGbl_ParseOpRoot);
     fprintf (stderr, "\n");
 
diff --git a/sys/contrib/dev/acpica/source/common/adwalk.c b/sys/contrib/dev/acpica/source/common/adwalk.c
index 6bd6f50..d150f4d 100644
--- a/sys/contrib/dev/acpica/source/common/adwalk.c
+++ b/sys/contrib/dev/acpica/source/common/adwalk.c
@@ -760,11 +760,13 @@ AcpiDmXrefDescendingOp (
 
     if ((!(OpInfo->Flags & AML_NAMED)) &&
         (!(OpInfo->Flags & AML_CREATE)) &&
-        (Op->Common.AmlOpcode != AML_INT_NAMEPATH_OP))
+        (Op->Common.AmlOpcode != AML_INT_NAMEPATH_OP) &&
+        (Op->Common.AmlOpcode != AML_NOTIFY_OP))
     {
         goto Exit;
     }
 
+
     /* Get the NamePath from the appropriate place */
 
     if (OpInfo->Flags & AML_NAMED)
@@ -801,6 +803,10 @@ AcpiDmXrefDescendingOp (
             Path = NextOp->Common.Value.String;
         }
     }
+    else if (Op->Common.AmlOpcode == AML_NOTIFY_OP)
+    {
+        Path = Op->Common.Value.Arg->Asl.Value.String;
+    }
     else
     {
         Path = Op->Common.Value.String;
diff --git a/sys/contrib/dev/acpica/source/common/ahids.c b/sys/contrib/dev/acpica/source/common/ahids.c
new file mode 100644
index 0000000..851393b
--- /dev/null
+++ b/sys/contrib/dev/acpica/source/common/ahids.c
@@ -0,0 +1,214 @@
+/******************************************************************************
+ *
+ * Module Name: ahids - Table of ACPI/PNP _HID/_CID values
+ *
+ *****************************************************************************/
+
+/*
+ * Copyright (C) 2000 - 2014, Intel Corp.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions, and the following disclaimer,
+ *    without modification.
+ * 2. Redistributions in binary form must reproduce at minimum a disclaimer
+ *    substantially similar to the "NO WARRANTY" disclaimer below
+ *    ("Disclaimer") and any redistribution must be conditioned upon
+ *    including a substantially similar Disclaimer requirement for further
+ *    binary redistribution.
+ * 3. Neither the names of the above-listed copyright holders nor the names
+ *    of any contributors may be used to endorse or promote products derived
+ *    from this software without specific prior written permission.
+ *
+ * Alternatively, this software may be distributed under the terms of the
+ * GNU General Public License ("GPL") version 2 as published by the Free
+ * Software Foundation.
+ *
+ * NO WARRANTY
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDERS OR CONTRIBUTORS BE LIABLE FOR SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGES.
+ */
+
+#include "acpi.h"
+#include "accommon.h"
+
+#define _COMPONENT          ACPI_UTILITIES
+        ACPI_MODULE_NAME    ("ahids")
+
+
+/*
+ * ACPI/PNP Device IDs with description strings
+ */
+const AH_DEVICE_ID  AslDeviceIds[] =
+{
+    {"10EC5640",    "Realtek I2S Audio Codec"},
+    {"80860F0A",    "Intel Atom UART Controller"},
+    {"80860F14",    "Intel Baytrail SDIO/MMC Host Controller"},
+    {"80860F28",    "Intel SST Audio DSP"},
+    {"80860F41",    "Intel Baytrail I2C Host Controller"},
+    {"ACPI0001",    "SMBus 1.0 Host Controller"},
+    {"ACPI0002",    "Smart Battery Subsystem"},
+    {"ACPI0003",    "Power Source Device"},
+    {"ACPI0004",    "Module Device"},
+    {"ACPI0005",    "SMBus 2.0 Host Controller"},
+    {"ACPI0006",    "GPE Block Device"},
+    {"ACPI0007",    "Processor Device"},
+    {"ACPI0008",    "Ambient Light Sensor Device"},
+    {"ACPI0009",    "I/O xAPIC Device"},
+    {"ACPI000A",    "I/O APIC Device"},
+    {"ACPI000B",    "I/O SAPIC Device"},
+    {"ACPI000C",    "Processor Aggregator Device"},
+    {"ACPI000D",    "Power Meter Device"},
+    {"ACPI000E",    "Time and Alarm Device"},
+    {"ACPI000F",    "User Presence Detection Device"},
+    {"ATK4001",     "Asus Radio Control Button"},
+    {"ATML1000",    "Atmel Touchscreen Controller"},
+    {"BCM2E39",     "Broadcom BT Serial Bus Driver over UART Bus Enumerator"},
+    {"CPLM3218",    "Capella Micro CM3218x Ambient Light Sensor"},
+    {"DELLABCE",    "Dell Airplane Mode Switch Driver"},
+    {"DLAC3002",    "Qualcomm Atheros Bluetooth UART Transport"},
+    {"INT0002",     "Virtual GPIO Controller"},
+    {"INT0800",     "Intel 82802 Firmware Hub Device"},
+    {"INT3394",     "ACPI System Fan"},
+    {"INT3396",     "Standard Power Management Controller"},
+    {"INT33A0",     "Intel Smart Connect Technology Device"},
+    {"INT33A1",     "Intel Power Engine"},
+    {"INT33BB",     "Intel Baytrail SD Host Controller"},
+    {"INT33BD",     "Intel Baytrail Mailbox Device"},
+    {"INT33C0",     "Intel Serial I/O SPI Host Controller"},
+    {"INT33C1",     "Intel Serial I/O SPI Host Controller"},
+    {"INT33C2",     "Intel Serial I/O I2C Host Controller"},
+    {"INT33C3",     "Intel Serial I/O I2C Host Controller"},
+    {"INT33C4",     "Intel Serial I/O UART Host Controller"},
+    {"INT33C5",     "Intel Serial I/O UART Host Controller"},
+    {"INT33C6",     "Intel SD Host Controller"},
+    {"INT33C7",     "Intel Serial I/O GPIO Host Controller"},
+    {"INT33C8",     "Intel Smart Sound Technology Host Controller"},
+    {"INT33C9",     "Wolfson Microelectronics Audio WM5102"},
+    {"INT33CA",     "Intel SPB Peripheral"},
+    {"INT33CB",     "Intel Smart Sound Technology Audio Codec"},
+    {"INT33D1",     "Intel GPIO Buttons"},
+    {"INT33D2",     "Intel GPIO Buttons"},
+    {"INT33D3",     "Intel GPIO Buttons"},
+    {"INT33D4",     "Intel GPIO Buttons"},
+    {"INT33D6",     "Intel Virtual Buttons Device"},
+    {"INT33F0",     "Camera Sensor MT9M114"},
+    {"INT33FB",     "MIPI-CSI Camera Sensor OV2722"},
+    {"INT33FC",     "Intel Baytrail GPIO Controller"},
+    {"INT33FD",     "Intel Baytrail Power Management IC"},
+    {"INT3400",     "Intel Dynamic Power Performance Management"},
+    {"INT3401",     "Intel Extended Thermal Model CPU"},
+    {"INT3403",     "DPTF Temperature Sensor"},
+    {"INT3406",     "Intel Dynamic Platform & Thermal Framework Display Participant"},
+    {"INT3407",     "DPTF Platform Power Meter"},
+    {"INT340E",     "Motherboard Resources"},
+    {"INT3420",     "Intel Bluetooth RF Kill"},
+    {"INT3F0D",     "ACPI Motherboard Resources"},
+    {"INTCF1A",     "Sony IMX175 Camera Sensor"},
+    {"INTCFD9",     "Intel Baytrail SOC GPIO Controller"},
+    {"INTL9C60",    "Intel Baytrail SOC DMA Controller"},
+    {"INVN6500",    "InvenSense MPU-6500 Six Axis Gyroscope and Accelerometer"},
+    {"LNXCPU",      "Linux Logical CPU"},
+    {"LNXPOWER",    "ACPI Power Resource (power gating)"},
+    {"LNXPWRBN",    "System Power Button"},
+    {"LNXSYBUS",    "System Bus"},
+    {"LNXSYSTM",    "ACPI Root Node"},
+    {"LNXTHERM",    "ACPI Thermal Zone"},
+    {"LNXVIDEO",    "ACPI Video Controller"},
+    {"MSFT0101",    "TPM 2.0 Security Device"},
+    {"NXP5442",     "NXP 5442 Near Field Communications Controller"},
+    {"PNP0000",     "8259-compatible Programmable Interrupt Controller"},
+    {"PNP0001",     "EISA Interrupt Controller"},
+    {"PNP0002",     "MCA Interrupt Controller"},
+    {"PNP0003",     "IO-APIC Interrupt Controller"},
+    {"PNP0100",     "PC-class System Timer"},
+    {"PNP0103",     "HPET System Timer"},
+    {"PNP0200",     "PC-class DMA Controller"},
+    {"PNP0300",     "IBM PC/XT Keyboard Controller (83 key)"},
+    {"PNP0301",     "IBM PC/XT Keyboard Controller (86 key)"},
+    {"PNP0302",     "IBM PC/XT Keyboard Controller (84 key)"},
+    {"PNP0303",     "IBM Enhanced Keyboard (101/102-key, PS/2 Mouse)"},
+    {"PNP0400",     "Standard LPT Parallel Port"},
+    {"PNP0401",     "ECP Parallel Port"},
+    {"PNP0500",     "Standard PC COM Serial Port"},
+    {"PNP0501",     "16550A-compatible COM Serial Port"},
+    {"PNP0510",     "Generic IRDA-compatible Device"},
+    {"PNP0800",     "Microsoft Sound System Compatible Device"},
+    {"PNP0A03",     "PCI Bus"},
+    {"PNP0A05",     "Generic Container Device"},
+    {"PNP0A06",     "Generic Container Device"},
+    {"PNP0A08",     "PCI Express Bus"},
+    {"PNP0B00",     "AT Real-Time Clock"},
+    {"PNP0B01",     "Intel PIIX4-compatible RTC/CMOS Device"},
+    {"PNP0B02",     "Dallas Semiconductor-compatible RTC/CMOS Device"},
+    {"PNP0C01",     "System Board"},
+    {"PNP0C02",     "PNP Motherboard Resources"},
+    {"PNP0C04",     "x87-compatible Floating Point Processing Unit"},
+    {"PNP0C08",     "ACPI Core Hardware"},
+    {"PNP0C09",     "Embedded Controller Device"},
+    {"PNP0C0A",     "Control Method Battery"},
+    {"PNP0C0B",     "Fan (Thermal Solution)"},
+    {"PNP0C0C",     "Power Button Device"},
+    {"PNP0C0D",     "Lid Device"},
+    {"PNP0C0E",     "Sleep Button Device"},
+    {"PNP0C0F",     "PCI Interrupt Link Device"},
+    {"PNP0C10",     "System Indicator Device"},
+    {"PNP0C11",     "Thermal Zone"},
+    {"PNP0C12",     "Device Bay Controller"},
+    {"PNP0C14",     "Windows Management Instrumentation Device"},
+    {"PNP0C15",     "Docking Station"},
+    {"PNP0C40",     "Standard Button Controller"},
+    {"PNP0C50",     "HID Protocol Device (I2C bus)"},
+    {"PNP0C60",     "Display Sensor Device"},
+    {"PNP0C70",     "Dock Sensor Device"},
+    {"PNP0C80",     "Memory Device"},
+    {"PNP0D40",     "Standard Compliant SD Host Controller"},
+    {"PNP0D80",     "Windows-compatible System Power Management Controller"},
+    {"PNP0F03",     "Microsoft PS/2-style Mouse"},
+    {"SMO91D0",     "Sensor Hub"},
+
+    {NULL, NULL}
+};
+
+
+/*******************************************************************************
+ *
+ * FUNCTION:    AcpiAhMatchHardwareId
+ *
+ * PARAMETERS:  HardwareId          - String representation of an _HID or _CID
+ *
+ * RETURN:      ID info struct. NULL if HardwareId is not found
+ *
+ * DESCRIPTION: Lookup an _HID/_CID in the device ID table
+ *
+ ******************************************************************************/
+
+const AH_DEVICE_ID *
+AcpiAhMatchHardwareId (
+    char                    *HardwareId)
+{
+    const AH_DEVICE_ID      *Info;
+
+
+    for (Info = AslDeviceIds; Info->Name; Info++)
+    {
+        if (!ACPI_STRCMP (HardwareId, Info->Name))
+        {
+            return (Info);
+        }
+    }
+
+    return (NULL);
+}
